
# ToyBox

This mod allows you to import your own models into maps and let units interact with them.\
This includes:
* Units pathfinding around your objects
* Objects having collision
* Objects being affected by physics

You can edit several aspects of your objects through an easy-to-use editor.\
This includes:
* Position
* Rotation
* Scale

And two buttons:

* Duplicate
* Destroy

### If you have trouble with the mod, or if you just want to chat, you can join the [TABS Mod Center](https://discord.gg/zrs44qyp7S).

# How To Install

> **ℹ️ The mod comes packaged with a bunch of objects made by the community that you can extract in the ToyBox folder!**

This mod can be installed like any other mod but requires another step.\
In order for users to import custom models, a folder is needed on top of the usual mod file.

You'll want to start the game once and close it for the folder to be created.\
When the folder is created, the next step will depend on whether you downloaded the mod manually, or with a mod manager.

### **- Manual**
Simply navigate to your plugins folder, and you should find the ToyBox folder.

### **- Thunderstore Mod Manager / r2modman**

#### **Video tutorial now available by clicking [here](https://www.youtube.com/watch?v=6xIc3nnEVBA)!**

Go to your profile, click settings and **Browse profile folder**

![](https://cdn.discordapp.com/attachments/999062030902382753/1028596864007815268/unknown.png)

Once in file explorer, go to **BepInEx > plugins > ToyBox** and place your .obj files inside.

# How To Use

### Importing Models

To import your own models, you'll want to navigate to the ToyBox folder (Refer to **How To Install** section).\
Inside this folder, you'll be able to place your object files.\
These object files must be in the **.obj** format and this format **only**.\
Object files can be accompanied by a **.mtl** file to apply colors and textures to it.

### ToyBox Editor

You can choose to show or hide the ToyBox editor by clicking a button in the top left section of your screen while playing on a map.\
Inside this Editor, you'll be able to spawn and edit several aspects of an object, such as position, rotation, scale...\
You can also click a button to duplicate or destroy it.

In order for units to pathfind around your objects, make sure they have the **Affect Pathfinding** option turned on.\
Then, you simply have to click **Bake Pathfinding** to make it take into account your object.\
You can toggle the visibility of pathfinding nodes to make sure the baking was successful.

If something is not working as you think it should, please refer to the FAQ to check whether it's a bug or simply a feature not implemented yet.

### ToyBox Saves

This window is dedicated to saving and loading your custom ToyBox maps.\
You can click a button in the list to load your saved layouts.\
If you save a map with the same name as an existing one, it will be overwritten.

Your saves are stored in a new folder, next to the models one called **ToyBoxSaves**\
Each save ends in **.toyl** and lives inside a subfolder which is named after the map.\
Example: `ToyBoxSaves\04_Sandbox_Viking_VC\mySave.toyl`

# FAQ

>**⚠️ Please read this section before reporting any bug or suggesting any feature!**

### You can find a more complete feature and bug list by clicking [here](https://trello.com/b/BVQnL7M5/toybox)!

### **[Q] The object list is empty!**
* Make sure your ToyBox folder containing your object files is not empty and is at the right place. 
* Refer to the **How To Install** section for installation.

### **[Q] Some maps have a broken pathfinding once updated!**
* You may have noticed on maps like Dynasty that updating the pathfinding causes unit to go and drown...
* Unfortunately, there's not much I can do about that, so unless I find a decent solution, I'd recommend using other more stable maps.

# Changelog

**- (2.0.0)**
* Added a new saving and loading feature.
* Fixed incompatibility with the **MetalMetals** mod.

**- (1.1.0)**
* Added a new search bar.
* Added a bunch of **.obj** files made by the community, you can find the credits in the section below.
* Subfolders are now supported in ToyBox folder.
* Maps that don't have pathfinding will now have one generated.
* Pathfinding baking bounds will now expand to all objects in the map automatically.
* The button list is now refreshed in real time - adding or removing **.obj** files while the game is running will update the ToyBox editor accordingly.

**- (1.0.4)**
* Fixed the horrible lag when inside main menu / unit creator.

**- (1.0.3)**
* Added back the missing ToyBox.zip containing the objects in 1.0.2 (sorry about that).

**- (1.0.2)**
* Fixed the ToyBox button being placed too low on the UI.
* Added a video tutorial to help with the installation using mod managers.

**- (1.0.1)**
* Fixed **How To Install** section having the wrong installation path for the mod managers.

**- (1.0.0)**
* **ToyBox** Release.
  
# Credits

### Fern
* Creator
* Coder

### Terren
* Name

### [Kenney](https://www.kenney.nl/), Wisefan, Hambody, Hyeong, Based Emoti (and others)
* Bunch of amazing assets!

### Dummiesman
* [Runtime OBJ Importer](https://assetstore.unity.com/packages/tools/modeling/runtime-obj-importer-49547)

### HiddenMonk
* [Unity 3D Runtime Transform Gizmo](https://github.com/HiddenMonk/Unity3DRuntimeTransformGizmo)

# Gallery

![](https://cdn.discordapp.com/attachments/999062030902382753/1028628107571249172/unknown.png)

![](https://cdn.discordapp.com/attachments/999062030902382753/1028628444596150272/unknown.png)

![](https://cdn.discordapp.com/attachments/1027974481102250084/1033344855532912690/SPOILER_unknown.png)

![](https://cdn.discordapp.com/attachments/1027974481102250084/1032564921331875880/Screenshot_2022-10-20_16-02-50.png)

![](https://cdn.discordapp.com/attachments/1027974481102250084/1033285949125316648/Screenshot_2022-10-22_15-48-12.png)

![](https://cdn.discordapp.com/attachments/999062030902382753/1033404188350230678/unknown.png)

![](https://cdn.discordapp.com/attachments/1027974481102250084/1033354924530094190/20221022194930_1.jpg)

![](https://cdn.discordapp.com/attachments/755818262654091285/1033012909896388728/Screenshot_2022-10-21_20-25-34.png)

![](https://cdn.discordapp.com/attachments/1027974481102250084/1033349355077382214/funny1.png)

![](https://cdn.discordapp.com/attachments/755818262654091285/1033012909548240896/Screenshot_2022-10-21_20-21-47.png)